package com.engine.jucailinkq.attendance.component.page.cmd;

import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.core.interceptor.CommandContext;
import com.engine.jucailinkq.attendance.enums.AccountingUnitEnum;
import com.engine.jucailinkq.common.util.DateUtil;
import com.engine.jucailinkq.common.util.DbTools;
import com.engine.jucailinkq.common.util.Utils;
import com.google.common.collect.Maps;
import weaver.general.Util;
import weaver.hrm.User;

import java.util.Calendar;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

public class GetPersonPageServiceCmd extends AbstractCommonCommand<Map<String,Object>> {


    public GetPersonPageServiceCmd(Map<String,Object> params, User user){
        this.params=params;
        this.user=user;
    }
    @Override
    public BizLogContext getLogContext() {
        return null;
    }

    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
        String generateDate = Util.null2String(params.get("generateDate"));
        String userId = Util.null2String(params.get("userId"));
        if ("".equals(userId)){
            userId = String.valueOf(user.getUID());
        }
        String nowDate = Util.null2String(params.get("nowDate"));
        if ("".equals(nowDate)){
            nowDate = DateUtil.getCurrentDate();
        }
        String nowYearDate = nowDate.split("-")[0]+"-01-01";
        String nowYearendDate = nowDate.split("-")[0]+"-12-31";


        Map<String,Object> resultMap = Maps.newHashMap();
        String sql = "select * from uf_jcl_kq_jqye where  ygid=? and yqsxrq>=? and sxrq<=?";
        List<Map<String, Object>> holidayDataList = DbTools.getSqlToList(sql,userId,nowDate,nowDate);
        Map<String,List<Map<String, Object>>> holidayDataGroup = holidayDataList.stream().collect(Collectors.groupingBy(e->e.get("jqid").toString()));
        Map<String,Map<String,Object>> holidayMap = Maps.newHashMap();
        sql = "select id,mc,hsdw  from uf_jcl_kq_kqxm";
        Map<String,List<Map<String,Object>>> itemGroupId = DbTools.getSqlToList(sql).stream().collect(Collectors.groupingBy(e->e.get("id").toString()));
        //Map<String,Object> itemMap = DbTools.getSqlToMapList(sql);
        for (Map.Entry<String,List<Map<String, Object>>> entry:holidayDataGroup.entrySet()){
            String jqid = entry.getKey();
            List<Map<String, Object>> dataList = entry.getValue();

            List<Map<String, Object>> oldData = dataList.stream().filter(e-> DateUtil.getTime(e.get("sxrq").toString())
                    .compareTo(DateUtil.getTime(nowYearDate)) <0).collect(Collectors.toList());

            List<Map<String, Object>> nowData = dataList.stream().filter(e-> DateUtil.getTime(e.get("sxrq").toString())
                    .compareTo(DateUtil.getTime(nowYearDate)) >=0 && DateUtil.getTime(e.get("sxrq").toString())
                    .compareTo(DateUtil.getTime(nowYearendDate)) <=0).collect(Collectors.toList());

            double allHoliday = dataList.stream().mapToDouble(e->Double.valueOf(e.get("wxsc").toString())).sum();
            double oldHoliday = oldData.stream().mapToDouble(e->Double.valueOf(e.get("wxsc").toString())).sum();
            double nowHoliday = allHoliday-oldHoliday;
            Map<String,Object> map = Maps.newHashMap();
            map.put("allHoliday",allHoliday);
            map.put("oldHoliday",oldHoliday);
            map.put("nowHoliday",nowHoliday);
            map.put("holidayName",Util.null2String(itemGroupId.get(jqid).get(0).get("mc")));
            map.put("hsdw",Util.null2String(itemGroupId.get(jqid).get(0).get("hsdw")));
            holidayMap.put(jqid,map);
        }
        sql = "select jqxm,zsdw,tzhwxs,zjq from uf_jcl_kq_holidayshowset where zt=1";
        List<Map<String,Object>> holidayShowSet = DbTools.getSqlToList(sql);
        Map<String,Map<String,Object>> newholidayMap = Maps.newHashMap();
        for (Map<String,Object> holidayShow:holidayShowSet){
            String jqxm = Util.null2String(holidayShow.get("jqxm"));
            Map<String,Object> fatherHoliday = holidayMap.get(jqxm);
            if (fatherHoliday == null){
                continue;
            }
            String sonjqxm = Util.null2String(holidayShow.get("zjq"));
            String zsdw = Util.null2String(holidayShow.get("zsdw"));
            String tzhwxs = Util.null2String(holidayShow.get("tzhwxs"));
            if (!"".equals(sonjqxm)){
                for (String item:sonjqxm.split(",")){
                    Map<String,Object> sonHoliday = holidayMap.get(item);
                    if (sonHoliday != null){
                        fatherHoliday.put("allHoliday",Double.valueOf(fatherHoliday.get("allHoliday").toString())+Double.valueOf(sonHoliday.get("allHoliday").toString()));
                        fatherHoliday.put("oldHoliday",Double.valueOf(fatherHoliday.get("oldHoliday").toString())+Double.valueOf(sonHoliday.get("oldHoliday").toString()));
                        fatherHoliday.put("nowHoliday",Double.valueOf(fatherHoliday.get("nowHoliday").toString())+Double.valueOf(sonHoliday.get("nowHoliday").toString()));
                    }
                }
            }
            String hsdw = Util.null2String(fatherHoliday.get("hsdw"));
            double tzhwxsValue = Double.valueOf(tzhwxs);
            if (zsdw.equals("0")){
                //天

                if (AccountingUnitEnum.HOUR.getKey().equals(hsdw) && !"".equals(tzhwxs)){

                    fatherHoliday.put("allHoliday", Utils.divide(Double.valueOf(fatherHoliday.get("allHoliday").toString()),tzhwxsValue));
                    fatherHoliday.put("oldHoliday", Utils.divide(Double.valueOf(fatherHoliday.get("oldHoliday").toString()),tzhwxsValue));
                    fatherHoliday.put("nowHoliday", Utils.divide(Double.valueOf(fatherHoliday.get("nowHoliday").toString()),tzhwxsValue));

                }else if (AccountingUnitEnum.MINUTES.getKey().equals(hsdw)){

                    fatherHoliday.put("allHoliday", Utils.divide(Double.valueOf(fatherHoliday.get("allHoliday").toString()),tzhwxsValue*60));
                    fatherHoliday.put("oldHoliday", Utils.divide(Double.valueOf(fatherHoliday.get("oldHoliday").toString()),tzhwxsValue*60));
                    fatherHoliday.put("nowHoliday", Utils.divide(Double.valueOf(fatherHoliday.get("nowHoliday").toString()),tzhwxsValue*60));

                }
            }else if (zsdw.equals("1")){
                //小时
                if (AccountingUnitEnum.DAY.getKey().equals(hsdw) && !"".equals(tzhwxs)){
                    fatherHoliday.put("allHoliday", Double.valueOf(fatherHoliday.get("allHoliday").toString())*tzhwxsValue);
                    fatherHoliday.put("oldHoliday", Double.valueOf(fatherHoliday.get("oldHoliday").toString())*tzhwxsValue);
                    fatherHoliday.put("nowHoliday", Double.valueOf(fatherHoliday.get("nowHoliday").toString())*tzhwxsValue);
                }else if (AccountingUnitEnum.MINUTES.getKey().equals(hsdw)){

                    fatherHoliday.put("allHoliday", Double.valueOf(fatherHoliday.get("allHoliday").toString())*60);
                    fatherHoliday.put("oldHoliday", Double.valueOf(fatherHoliday.get("oldHoliday").toString())*60);
                    fatherHoliday.put("nowHoliday", Double.valueOf(fatherHoliday.get("nowHoliday").toString())*60);

                }


            }
            newholidayMap.put(jqxm,fatherHoliday);


        }

        resultMap.put("holiday",newholidayMap);
        int diffdays = DateUtil.getDays(generateDate, Calendar.DAY_OF_MONTH);
        String startDate = generateDate + "-01";
        String endDate = generateDate + "-" + diffdays;

        sql = "select id,jc,ys from uf_jcl_kq_bcxx";
        List<Map<String,Object>> classList = DbTools.getSqlToList(sql);
        Map<String,List<Map<String,Object>>> classGroup = classList.stream().collect(Collectors.groupingBy(e->e.get("id").toString()));



        sql = "select * from uf_jcl_kq_cqjg where ygid=? and rq>=? and rq<=?";
        List<Map<String,Object>> attendaceResultList = DbTools.getSqlToList(sql,userId,startDate,endDate);
        for (Map<String,Object> attendaceResult:attendaceResultList){
            Map<String,Object> attendaceResultItem = Maps.newHashMap();
            for (int i=1;i<=8;i++){
                String xm = "xm" + i;
                String sc = "sc" + i;
                String item = Util.null2String(attendaceResult.get(xm));
                if (!"".equals(item)){
                    String time = attendaceResult.get(sc).toString();
                    double havedAskforTime = attendaceResultItem.get(item) == null?0:Double.valueOf(attendaceResultItem.get(item).toString());
                    havedAskforTime = havedAskforTime+Double.valueOf(Util.null2String(time).equals("")?"1":Util.null2String(time));
                    attendaceResultItem.put(item,havedAskforTime);
                }
            }
            Map<String,Object> attendaceResultItemName = Maps.newHashMap();
            for (Map.Entry<String,Object> entry:attendaceResultItem.entrySet()){
                attendaceResultItemName.put(Util.null2String(itemGroupId.get(entry.getKey()).get(0).get("mc")),entry.getValue());
            }
            attendaceResult.put("attendaceResultItemName",attendaceResultItemName);
            List<Map<String,Object>> classes = classGroup.get(attendaceResult.get("bc"));
            if (classes != null && classes.size() >0){
                attendaceResult.put("bcname",classes.get(0).get("jc"));
                attendaceResult.put("ys",classes.get(0).get("ys"));
            }
        }
        resultMap.put("attendaceResult",attendaceResultList);

        return resultMap;
    }
}
